Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Static Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends | List of all members
TiXmlBase Class Referenceabstract

`#include <tinyxml.h>`

Inheritance diagram for TiXmlBase:

## Public Types
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }

## Public Member Functions
| TiXmlBase ()
virtual | ~TiXmlBase ()
virtual void | Print (FileStream &stream, int depth) const =0
int | Row () const
int | Column () const
| See Row() More...
void | SetUserData (void *user)
| Set a pointer to arbitrary user data. More...
void * | GetUserData ()
| Get a pointer to arbitrary user data. More...
const void * | GetUserData () const
| Get a pointer to arbitrary user data. More...
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)=0

## Static Public Member Functions
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting. More...
static void | EncodeString (const TIXML_STRING &str, TIXML_STRING *out)

## Static Public Attributes
static const int | utf8ByteTable [256]

## Static Protected Member Functions
static const char * | SkipWhiteSpace (const char *, TiXmlEncoding encoding)
static bool | IsWhiteSpace (char c)
static bool | IsWhiteSpace (int c)
static const char * | ReadName (const char *p, TIXML_STRING *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)

## Protected Attributes
TiXmlCursor | location
void * | userData
| Field containing a generic user pointer. More...

## Static Protected Attributes
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Friends
class | TiXmlNode
class | TiXmlElement
class | TiXmlDocument

## Detailed Description

TiXmlBase is a base class for every class in TinyXml. It does little except to establish that TinyXml classes can be printed and provide some utility functions.

In XML, the document and elements can contain other elements and other types of nodes.

    A Document can contain: Element (container or leaf)
                            Comment (leaf)
                            Unknown (leaf)
                            Declaration( leaf )

    An Element can contain: Element (container or leaf)
                            Text    (leaf)
                            Attributes (not on tree)
                            Comment (leaf)
                            Unknown (leaf)

    A Decleration contains: Attributes (not on tree)

## Member Enumeration Documentation

anonymous enum

Enumerator
TIXML_NO_ERROR |
TIXML_ERROR |
TIXML_ERROR_OPENING_FILE |
TIXML_ERROR_PARSING_ELEMENT |
TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME |
TIXML_ERROR_READING_ELEMENT_VALUE |
TIXML_ERROR_READING_ATTRIBUTES |
TIXML_ERROR_PARSING_EMPTY |
TIXML_ERROR_READING_END_TAG |
TIXML_ERROR_PARSING_UNKNOWN |
TIXML_ERROR_PARSING_COMMENT |
TIXML_ERROR_PARSING_DECLARATION |
TIXML_ERROR_DOCUMENT_EMPTY |
TIXML_ERROR_EMBEDDED_NULL |
TIXML_ERROR_PARSING_CDATA |
TIXML_ERROR_DOCUMENT_TOP_ONLY |
TIXML_ERROR_STRING_COUNT |

## Constructor & Destructor Documentation

TiXmlBase | ( |  | ) |
| inline

virtual ~TiXmlBase | ( |  | ) |
| inline virtual

## Member Function Documentation

int Column | ( |  | ) | const
| inline

See Row()

void ConvertUTF32ToUTF8 | ( | unsigned long | input,
|  | char * | output,
|  | int * | length
| ) |  |
| static protected

void EncodeString | ( | const TIXML_STRING & | str,
|  | TIXML_STRING * | out
| ) |  |
| static

Expands entities in a string. Note this should not contian the tag's '<', '>', etc, or they will be transformed into entities!

static const char* GetChar | ( | const char * | p,
|  | char * | _value,
|  | int * | length,
|  | TiXmlEncoding | encoding
| ) |  |
| inline static protected

const char * GetEntity | ( | const char * | in,
|  | char * | value,
|  | int * | length,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

void* GetUserData | ( |  | ) |
| inline

Get a pointer to arbitrary user data.

const void* GetUserData | ( |  | ) | const
| inline

Get a pointer to arbitrary user data.

int IsAlpha | ( | unsigned char | anyByte,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

int IsAlphaNum | ( | unsigned char | anyByte,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

static bool IsWhiteSpace | ( | char | c | ) |
| inline static protected

static bool IsWhiteSpace | ( | int | c | ) |
| inline static protected

static bool IsWhiteSpaceCondensed | ( |  | ) |
| inline static

Return the current white space setting.

virtual const char* Parse | ( | const char * | p,
|  | TiXmlParsingData * | data,
|  | TiXmlEncoding | encoding
| ) |  |
| pure virtual

Implemented in TiXmlDocument, TiXmlUnknown, TiXmlDeclaration, TiXmlText, TiXmlComment, TiXmlElement, and TiXmlAttribute.

virtual void Print | ( | FileStream & | stream,
|  | int | depth
| ) |  | const
| pure virtual

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert tabs and newlines.

(For an unformatted stream, use the << operator.)

Implemented in TiXmlDocument, TiXmlUnknown, TiXmlDeclaration, TiXmlText, TiXmlComment, TiXmlElement, and TiXmlAttribute.

const char * ReadName | ( | const char * | p,
|  | TIXML_STRING * | name,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

const char * ReadText | ( | const char * | in,
|  | TIXML_STRING * | text,
|  | bool | ignoreWhiteSpace,
|  | const char * | endTag,
|  | bool | ignoreCase,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

int Row | ( |  | ) | const
| inline

Return the position, in the original source file, of this node or attribute. The row and column are 1-based. (That is the first row and first column is 1,1). If the returns values are 0 or less, then the parser does not have a row and column value.

Generally, the row and column value will be set when the TiXmlDocument::Load(), TiXmlDocument::LoadFile(), or any TiXmlNode::Parse() is called. It will NOT be set when the DOM was created from operator>>.

The values reflect the initial load. Once the DOM is modified programmatically (by adding or changing nodes and attributes) the new values will NOT update to reflect changes in the document.

There is a minor performance cost to computing the row and column. Computation can be disabled if TiXmlDocument::SetTabSize() is called with 0 as the value.

See also
  TiXmlDocument::SetTabSize()

static void SetCondenseWhiteSpace | ( | bool | condense | ) |
| inline static

The world does not agree on whether white space should be kept or not. In order to make everyone happy, these global, static functions are provided to set whether or not TinyXml will condense all white space into a single space or not. The default is to condense. Note changing this value is not thread safe.

void SetUserData | ( | void * | user | ) |
| inline

Set a pointer to arbitrary user data.

const char * SkipWhiteSpace | ( | const char * | p,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

bool StringEqual | ( | const char * | p,
|  | const char * | endTag,
|  | bool | ignoreCase,
|  | TiXmlEncoding | encoding
| ) |  |
| static protected

static int ToLower | ( | int | v,
|  | TiXmlEncoding | encoding
| ) |  |
| inline static protected

## Friends And Related Function Documentation

friend class TiXmlDocument
| friend

friend class TiXmlElement
| friend

friend class TiXmlNode
| friend

## Member Data Documentation

const char * errorString
| static protected

Initial value:
=
{
"No error",
"Error",
"Failed to open file",
"Error parsing Element.",
"Failed to read Element name",
"Error reading Element value.",
"Error reading Attributes.",
"Error: empty tag.",
"Error reading end tag.",
"Error parsing Unknown.",
"Error parsing Comment.",
"Error parsing Declaration.",
"Error document empty.",
"Error null (0) or unexpected EOF found in input stream.",
"Error parsing CDATA.",
"Error when TiXmlDocument added to document, because TiXmlDocument can only be at the root.",
}

TiXmlCursor location
| protected

void* userData
| protected

Field containing a generic user pointer.

const int utf8ByteTable
| static

Initial value:
=
{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
4, 4, 4, 4, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
}

The documentation for this class was generated from the following files:

- persistence/tinyXML/tinyxml.h
- persistence/tinyXML/tinyxml.cpp
- persistence/tinyXML/tinyxmlerror.cpp
- persistence/tinyXML/tinyxmlparser.cpp